<?php

namespace BancoTalentos\Services;

use BancoTalentos\Repositories\GeralRepository;
use BancoTalentos\Util\{ Repositories, Util };

class GeralService {
    public function __construct(GeralRepository $geralRepository) {
        $this->geralRepository = $geralRepository;
    }

    public function getPais() {
        return $this->geralRepository->getPais();
    }

    public function getGrauinstrucao() {
        return $this->geralRepository->getGrauinstrucao();
    }

    public function getEstadocivil() {
        return $this->geralRepository->getEstadocivil();
    }

    public function getEstado($cdPais) {
        return $this->geralRepository->getEstado($cdPais);
    }

    public function getMunicipio($cdPais, $sgEstado) {
        return $this->geralRepository->getMunicipio($cdPais, $sgEstado);
    }

    public function getNacionalidade() {
        return $this->geralRepository->getNacionalidade();
    }

    public function isEmailTaken(string $email) {
        return !empty(Util::getEntityManager()->getRepository(Repositories::OPERADOR)->findOneBy(['dsemailoper' => $email]));
    }
}