<?php
namespace BancoTalentos\Services;

use BancoTalentos\Util\HcmServices;
use BancoTalentos\Util\BTParameters;
use Zeedhi\Framework\DTO;

class PerfilService {
    /** @param BTParameters */
    protected $btParameters;

    /** @param HcmServices */
    protected $hcmServices;

    public function __construct(
        BTParameters $btParameters,
        HcmServices $hcmServices
    ) {
        $this->btParameters = $btParameters;
        $this->hcmServices = $hcmServices;
    }

    public function generateResume(): string {
        $nrOrg = (int) $this->btParameters->getNrOrg();
        $nrParcNegocio = (int) $this->btParameters->getNrParcNegocio();
        $nmOperador = $this->btParameters->getNmOperador();
        $pathFoto = '';

        $competencia = date('01/m/Y');
        $reportName = 'curriculo_candidato';

        $route = 'generateBirtReport';

        $params = [
            'requestType' => 'Row',
            'row' => [
                'reportName' => $reportName,
                'P_NRORG' => $nrOrg,
                'P_NRPARCNEGOCIO' => $nrParcNegocio,
                'P_NMOPERADOR' => $nmOperador,
                'P_COMPETENCIA' => $competencia,
                'P_PATH_FOTO' => $pathFoto,
            ],
        ];

        $response = $this->hcmServices->send($route, $params, $nrOrg);
        $reportLink = (string) $response['dataset'][$route]['link'];

        return $reportLink;
    }

}